local addonVar = Npcm.getVar() -- copie de la locale addonVar pour ce fichier
local markersOrder = Npcm.getMarkersOrder() -- copie pour ce fichier
local frameListPlayers -- raid/party players scroll frame
local tblPlayers -- raid/party players list

---------------------------------------------------------------------------------------
---------------------------- CONSTRUCTION MAIN FRAME (MJ)------------------------------
local iconSize = 36
local stringSize = 14
local colorMJ = {
	["normal"] = {
		["line"] = {{0.18,0.18,0.18}, {0.12,0.12,0.12}}, -- pour alternance lignes
		["update"] = "3A52AD"
	},
	["dark"] = {
		["line"] = {{0.18,0.18,0.18}, {0.12,0.12,0.12}}, -- pour alternance lignes
		["update"] = "3A52AD"
	},
}

local alphasMJ = { -- pour corrections alpha UI MJ
	["normal"] = {
		["active"] = {
			["line"] = 1,
			["marker"] = 1, -- fond btn
			["icnmarker"] = 0.9, -- icone raid
			["desc"] = 0.8,
			["hp"] = 0.6,
		},
		["inactive"] = {
			["line"] = 1,
			["marker"] = 1, -- fond btn
			["icnmarker"] = 0.7, -- icone raid
			["desc"] = 0.7,
			["hp"] = 0.5,
		},
	},
	["dark"] = {
		["active"] = {
			["line"] = 0.9,
			["marker"] = 0.8, -- fond btn
			["icnmarker"] = 1, -- icone raid
			["desc"] = 1, -- fond edit box
			["hp"] = 1,
			["attitudebtn"] = 1,
		},
		["inactive"] = {
			["line"] = 0.7,
			["marker"] = 0.2, -- fond btn
			["icnmarker"] = 0.7, -- icone raid
			["desc"] = 1, -- fond edit box
			["hp"] = 0.5,
			["attitudebtn"] = 0.7,
		},
	},
}
	
local npcm_frameAlert, npcm_frameBk, npcm_frameClient

local stringIconWorldmarkerPrefix = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"
local texGroundMarkers = {
	-- l'index d'affichage des markers ne correspond pas à leur numérotation /wm !
	[1] = {["tex"] = stringIconWorldmarkerPrefix.."8:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 8}, -- tete
	[2] = {["tex"] = stringIconWorldmarkerPrefix.."7:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 7}, -- croix
	[3] = {["tex"] = stringIconWorldmarkerPrefix.."6:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 6}, -- carré
	[4] = {["tex"] = stringIconWorldmarkerPrefix.."5:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 5}, -- lune
	[5] = {["tex"] = stringIconWorldmarkerPrefix.."4:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 4}, -- triangle
	[6] = {["tex"] = stringIconWorldmarkerPrefix.."3:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 3}, -- losange
	[7] = {["tex"] = stringIconWorldmarkerPrefix.."2:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 2}, -- rond
	[8] = {["tex"] = stringIconWorldmarkerPrefix.."1:"..stringSize..":"..stringSize.."|t", ["numRaidIcn"] = 1}, -- étoile
}

function Npcm.getMarkerIdFromSpell(spellID) -- ID des spells des markers
	local markersSpells = {
		[171557] = {["wm"] = markersOrder[1], ["index"] = 1},
		[84999] = {["wm"] = markersOrder[2], ["index"] = 2},
		[84996] = {["wm"] = markersOrder[3], ["index"] = 3},
		[171556] = {["wm"] = markersOrder[4], ["index"] = 4},
		[84997] = {["wm"] = markersOrder[5], ["index"] = 5},
		[84998] = {["wm"] = markersOrder[6], ["index"] = 6},
		[171555] = {["wm"] = markersOrder[7], ["index"] = 7},
		[85000] = {["wm"] = markersOrder[8], ["index"] = 8},
	}
	if (markersSpells[spellID] ~= nil) then
		return markersSpells[spellID]["index"]
	else
		return nil
	end
end

function Npcm.getRGBColorLine(attitude, hilitedBoolean) -- 0, 1, 2 ou 3 (colorisation suivant attitude)
	local attitude = attitude or 3
	local tbl
	if (hilitedBoolean) then -- couleurs vives
		tbl = {
			["0"] = {0.75,0.22,0.13}, -- rouge
			["1"] = {0.81,0.75,0}, -- jaune
			["2"] = {0.26,0.67,0.06}, -- vert
			["3"] = {0.5, 0.5, 0.5}, -- gris (inactif)
		}
	else
		tbl = {
			["0"] = {0.5,0.21,0.13}, -- rouge
			["1"] = {0.58,0.53,0}, -- jaune
			["2"] = {0.22,0.54,0.05}, -- vert
			["3"] = {0.2, 0.2, 0.2}, -- gris (inactif)
		}
	end
	if (Npcm.isDarkMJ()) then tbl["3"] = {0.08, 0.08, 0.08} end
	return tbl[tostring(attitude)]
end

function Npcm.changeColor(indexedColorTbl, offset) -- modification d'une couleur (sous forme de table)
	local offset = tonumber(offset) or 0
	if (type(indexedColorTbl) == "table") then
		for i, value in ipairs(indexedColorTbl) do
			indexedColorTbl[i] = max(0, min(1, value + offset))
		end
	end
	return indexedColorTbl
end

function Npcm.isDarkMJ() -- raccourci
	return (NPCM_SAVED["settings"]["mj"]["darkui"] == 1)
end

function Npcm.constructionFrameMJ() -- hidden par XML
	local vFrame = addonVar["dimUImj"]["vMenuBar"] + addonVar["dimUImj"]["vStatus"] + (addonVar["dimUImj"]["vLine"] * #markersOrder)
	npcm_frameMain:ClearAllPoints()
	npcm_frameMain:SetClampedToScreen(true)
	npcm_frameMain:SetMovable(true)
 	npcm_frameMain:SetUserPlaced(true)
    npcm_frameMain:SetResizable(true)
	npcm_frameMain:SetSize(addonVar["dimUImj"]["hFrame"], vFrame)
	------------------------------------------------------------------ barre titre
	local menubar = CreateFrame("Button", "$parent_menubar", npcm_frameMain)
	menubar:SetSize(addonVar["dimUImj"]["hFrame"], 16)
	menubar:SetPoint("TOPLEFT", npcm_frameMain, "TOPLEFT", 0, 0);
	-------------- texture
	menubar.texture = menubar:CreateTexture("$parent_tex","BACKGROUND")
	menubar.texture:SetAllPoints(true)
	menubar.texture:SetTexture(Npcm.getStuffPath("dm\\Npcm_menuBk", true))
	menubar:SetHighlightTexture(Npcm.getStuffPath("dm\\Npcm_menuBk", true))
	-------------- tooltip
    menubar:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:AddLine(Npcm.getLocal("Double-click to collapse/expand."))
		GameTooltip:AddLine(Npcm.getLocal("Control-mouse wheel to scale the frame."))
		GameTooltip:AddLine(Npcm.getLocal("Double-click with shift or ctrl to reset the scale."))
		GameTooltip:Show()
    end)
    menubar:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	------------- double-click : expand/collapse
	--menubar:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	menubar:SetScript("OnDoubleClick", function(self, mouse)
		if (mouse == "LeftButton" and IsModifierKeyDown()) then
			self:GetParent():SetScale(1)
			NPCM_SAVED["settings"]["mj"]["scale"] = 1
		else
			Npcm.expandUI()
		end
	end)
	------------- drag déplacement (clic-gauche avec modificateur, ou clic-droit)
	menubar:EnableMouse(true)
	menubar:SetScript("OnMouseDown", function(self, mouse)
		if (not npcm_frameMain.isMoving) then
			self:GetParent():StartMoving()
			self:GetParent().isMoving = true
		end
	end)
	menubar:SetScript("OnMouseUp", function(self, mouse)
		if (npcm_frameMain.isMoving) then
			self:GetParent():StopMovingOrSizing()
			self:GetParent().isMoving = false
			Npcm.saveFramesPosition()
		end
	end)
	------------- CTRL mouseWheel : scale
	menubar:EnableMouseWheel(true)
	menubar:SetScript("OnMouseWheel", function(self, mouseWheel)
		if (IsControlKeyDown()) then
			local frame = self:GetParent()
			local scale = frame:GetScale()
			if (mouseWheel > 0) then
				scale = min(scale + 0.05, 2)
			elseif (mouseWheel < 0) then
				scale = max(scale - 0.05, 0.5)
			end
			frame:SetScale(floor(scale * 100 + 0.5) / 100)
			--print(scale.."---"..(floor(scale * 100 + 0.5) / 100))
			NPCM_SAVED["settings"]["mj"]["scale"] = (floor(scale * 100 + 0.5) / 100)
		end
	end)
	
	------------- icone raid/groupe
	local partyIcon = CreateFrame("Frame", "$parent_partyIcon", menubar)
	partyIcon:SetSize(22, 12)
	partyIcon:SetPoint("LEFT", menubar, "LEFT", 14, -2)
	partyIcon.texture = partyIcon:CreateTexture(nil, "ARTWORK")
	partyIcon.texture:SetAllPoints(true)
	partyIcon:Hide()
	------------- titre
	local string = menubar:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormalSmall")
	string:SetPoint("CENTER",0,0)
	string:SetText(addonVar["name"].." "..Npcm.getVersionStr());
	string:SetJustifyH("CENTER")
	-------------------------------------------- popmenu (MENU TITRE)
	------------ popmenu : frame des articles menu
	local popupList = CreateFrame("Frame", "$parent_popupList", menubar, "UIDropDownMenuTemplate")
	------------- popup menu
	local popupBtn = CreateFrame("Button", "$parent_popupBtn", menubar)
	popupBtn:SetPoint("RIGHT", menubar, "RIGHT", -14, 0)
	popupBtn:SetSize(16, 16)
	popupBtn:SetFrameStrata("MEDIUM")
	popupBtn:SetNormalTexture(Npcm.getStuffPath("dm\\arrow_down", true))
	popupBtn:SetHighlightTexture(Npcm.getStuffPath("dm\\arrow_down", true))
	popupBtn:SetPushedTexture(Npcm.getStuffPath("dm\\arrow_down", true))
	UIDropDownMenu_Initialize(popupList, Npcm.createMenu, "MENU")
	popupBtn:SetScript("OnClick", function(self) Npcm.showMenu() end)
	
	------------------------------------------------------------------ frame transparent pour modif alpha
	npcm_frameBk = CreateFrame("Frame", "npcm_frameBk", npcm_frameMain, "SecureHandlerStateTemplate")
	npcm_frameBk:SetSize(addonVar["dimUImj"]["hFrame"], npcm_frameMain:GetHeight() - addonVar["dimUImj"]["vMenuBar"])
	npcm_frameBk:SetPoint("TOPLEFT", npcm_frameMain, "TOPLEFT", 0, 0 - addonVar["dimUImj"]["vMenuBar"]);
	if (Npcm.isDarkMJ()) then
		npcm_frameBk:SetAlpha(Npcm.nombreParDefaut(NPCM_SAVED["settings"]["mj"]["darkalpha"], 1)) -- pas de modif de la barre de titre
	else
		npcm_frameBk:SetAlpha(Npcm.nombreParDefaut(NPCM_SAVED["settings"]["mj"]["alpha"], 1)) -- pas de modif de la barre de titre
	end
	
	------------------------------------------------------------------ lignes
	Npcm.createUIlinesMJ()
	
	------------------------------------------------------------------ status
	local status = CreateFrame("Frame", "$parent_status", npcm_frameBk)
	status:SetSize(addonVar["dimUImj"]["hFrame"], addonVar["dimUImj"]["vStatus"])
	status:SetPoint("BOTTOMLEFT", npcm_frameBk, "BOTTOMLEFT", 0, 0)
	if (Npcm.isDarkMJ()) then
		Npcm.setColoredFrame(status, {0.1, 0.1, 0.1}, nil, 0, 0.6, nil)
	else
		Npcm.setColoredFrame(status, {0.4, 0.4, 0.4}, nil, 0, 0.9, nil)
	end
	------------- texte
	local statusStr = status:CreateFontString("$parent_Text", "OVERLAY")
	statusStr:SetPoint("LEFT", 4, 1)
	statusStr:SetJustifyH("LEFT")
	if (Npcm.isDarkMJ()) then
		Npcm.setFontStyle(statusStr, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 11, "8E95EA", false, 1)
	else
		Npcm.setFontStyle(statusStr, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 11, "8E95EA", false, 1)
	end
	status.fontString = statusStr
	------------ fcns
	status.GetText = function() return status.text end
	status.SetText = function(self, str)
		status.fontString:SetText(str)
	end
	
	------------------------------ bouton Update
	local color = "normal"
	if (Npcm.isDarkMJ()) then color = "dark" end
	color = colorMJ[color]["update"]
	local btnUpdate = Npcm.createRectButton("$parent_update", status, Npcm.getLocal("Update"), 75, status:GetHeight() - 2)
	Npcm.setColoredButton(btnUpdate, color, "222222", 0, 1, 0.5, nil)
	Npcm.setFontStyle(btnUpdate.text, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "BFB313", false, 1)
	btnUpdate:SetPoint("RIGHT", -1, 0)
	btnUpdate:SetScript("OnClick", function() Npcm.refresh() end) -- MAJ de SAVED et envoi toutes lignes au client

	------------------------------------------------------------------ 
	------------- placement définitif du frame principal suivant prefs (mieux ici)
	--print("posX = "..NPCM_SAVED["settings"]["mj"]["posX"].." / "..Npcm.entierParDefaut(NPCM_SAVED["settings"]["mj"]["posX"], 100).."    posY = "..NPCM_SAVED["settings"]["mj"]["posY"].." / "..Npcm.entierParDefaut(NPCM_SAVED["settings"]["mj"]["posY"], 100))--/////
	Npcm.expandUI(NPCM_SAVED["settings"]["mj"]["expanded"])
	npcm_frameMain:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Npcm.entierParDefaut(NPCM_SAVED["settings"]["mj"]["posX"], 100), Npcm.entierParDefaut(NPCM_SAVED["settings"]["mj"]["posY"], 700))
	npcm_frameMain:SetScale(Npcm.nombreParDefaut(NPCM_SAVED["settings"]["mj"]["scale"], 1))
end

function Npcm.createUIlinesMJ() -- creation d'une ligne par world marker
	for i = 1, #markersOrder do
		-------------------------------------------- frame ligne
		local fLine = CreateFrame("Frame", "$parent_fLine_"..i, npcm_frameBk)
		fLine:SetFrameStrata("BACKGROUND")
		fLine:SetSize(npcm_frameBk:GetWidth(), addonVar["dimUImj"]["vLine"])
		fLine:SetPoint("TOPLEFT", npcm_frameBk, "TOPLEFT", 0, 0 - (addonVar["dimUImj"]["vLine"]*(i - 1)))
		
		local bkColorLine = colorMJ["normal"]["line"] -- table pour alternance ligne
		local alphaLine = colorMJ["normal"]["alphabk"]
		Npcm.setColoredFrame(fLine, bkColorLine[mod(i-1, 2) + 1], nil, 0, alphaLine, nil)
		-------------------------------------------- button marker (posage et suppression marker)
		local stringIcon = texGroundMarkers[i]["tex"]
		local btnMarker = Npcm.createBtnMarker(fLine, "$parent_icn", stringIcon, i)
		btnMarker:SetPoint("TOPLEFT", fLine, "TOPLEFT", 8, -9)
		-------------------------- debug
		local labelDebug = fLine:CreateFontString("$parent_labelDebug", "OVERLAY", "GameFontNormalSmall")
		labelDebug:SetPoint("LEFT", button, "RIGHT", 2, 0)
		labelDebug:SetText(i.."-"..texGroundMarkers[i]["numRaidIcn"].."-"..markersOrder[i]);
		if (Npcm.debug()) then labelDebug:Show() else labelDebug:Hide() end
		-------------------------------------------- texte (desc)
		------------- edit text
		local editBox = CreateFrame("EditBox", "$parent_editBox", fLine)
		editBox:SetSize(160, 18)
		editBox:SetPoint("TOPLEFT", btnMarker, "TOPRIGHT", 40, 0)
		Npcm.setColoredFrame(editBox, Npcm.getRGBColorLine(3, false), nil, 0, 0.8, nil) -- attitude 3 : inactif
		-------------- 
		editBox:SetMultiLine(false)
		editBox:SetAutoFocus(false)
		editBox:SetTextInsets(6, 2, -1, 0) -- left, right, top, bottom
		editBox:SetMaxLetters(40)
		editBox:SetHighlightColor(0.33,0.42,0.78)
		editBox:SetFontObject("ChatFontNormal")
		editBox:SetScript("OnEditFocusGained", function(self) self:HighlightText(500, 500) end) -- ne pas sel tout le texte sur focus
		editBox:SetScript("OnEditFocusLost", function() Npcm.setDesc(i) end) -- MAJ du texte (Desc) sur perte focus
		editBox:SetScript("OnEscapePressed", function() Npcm.clickMJ(i) end)
		editBox:SetScript("OnEnterPressed", function() Npcm.clickMJ(i) end)
		------------- label
		local labelDesc = fLine:CreateFontString("$parent_labelDesc", "OVERLAY")
		labelDesc:SetJustifyH("LEFT")
		if (Npcm.isDarkMJ()) then
			Npcm.setFontStyle(labelDesc, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "CCCCCC", false, 0.8)
		else
			Npcm.setFontStyle(labelDesc, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "grey", false, 1)
		end
		----
		labelDesc:SetJustifyH("RIGHT")
		labelDesc:SetText(Npcm.getLocal("Name"))
		labelDesc:SetPoint("RIGHT", editBox, "LEFT", -6, -1)
		-------------------------------------------- HP
		local hpBtnWidth = 16; hpHeight = 14
		--------------------- bouton HP down
		local hparrowdown = Npcm.createUpDownButton(fLine, i, "down", hpBtnWidth, hpHeight)
		hparrowdown:SetPoint("LEFT", editBox, "LEFT", 0, 0)
		hparrowdown:SetPoint("BOTTOM", btnMarker, "BOTTOM", 0, 0)
		--------------------- boutons HP up
		local hparrowup = Npcm.createUpDownButton(fLine, i, "up", hpBtnWidth, hpHeight)
		hparrowup:SetPoint("RIGHT", editBox, "RIGHT", 0, 0)
		hparrowup:SetPoint("BOTTOM", btnMarker, "BOTTOM", 0, 0)
		--------------------- fond barre HP (entre les 2 boutons)
		local hpbk = CreateFrame("Frame", "$parent_hp_bk", fLine)
		hpbk:SetPoint("TOPLEFT", hparrowdown, "TOPRIGHT", 1, 0)
		hpbk:SetPoint("BOTTOMRIGHT", hparrowup, "BOTTOMLEFT", -1, 0)
		hpbk:SetHeight(hparrowdown:GetHeight()) -- pour appel ultérieur
		Npcm.setColoredFrame(hpbk, "555555", nil, 0, 0.9, nil)
		--------------------- label HP
		local labelHP = fLine:CreateFontString("$parent_labelDesc", "OVERLAY")
		labelHP:SetJustifyH("LEFT")
		if (Npcm.isDarkMJ()) then
			Npcm.setFontStyle(labelHP, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "CCCCCC", false, 0.8)
		else
			Npcm.setFontStyle(labelHP, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "grey", false, 1)
		end
		---
		labelHP:SetJustifyH("RIGHT")
		labelHP:SetText(Npcm.getLocal("HP").." %")
		labelHP:SetPoint("RIGHT", hparrowdown, "LEFT", -6, 0)
		--------------------- barre HP
		local hp = CreateFrame("Frame", "$parent_hpBar", fLine)
		hp:SetSize(hpbk:GetWidth() + 1, hpbk:GetHeight()) -- MAJ populate
		hp:SetPoint("LEFT", hpbk, "LEFT", 1, 0)
		local hpTex = hp:CreateTexture("$parent_tex", "ARTWORK")
		hpTex:SetAllPoints(true)
		hpTex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\player\\hpcli_3") -- MAJ populate par allumeRadioBtnsHP()
		hp.texture = hpTex
		-------------------------------------------- boss
		--[[ NOBOSS
		local checkBoss = CreateFrame("CheckButton", "$parent_checkBoss", fLine, "___________");
		checkBoss:SetSize(24, 24)
		checkBoss:SetPoint("TOPLEFT", label100, "TOPRIGHT", 10, 6)
		_G[(checkBoss:GetName().."Text")]:SetText("Boss")
		checkBoss:SetScript("OnClick", function(self) Npcm.setBoss(i, self:GetChecked()) end)
		--]]
		-------------------------------------------- radio buttons attitude
		-------------- fond boutons radio
		local attitudebk = CreateFrame("Frame", "$parent_attitude", fLine) -- nécessaire pour calage boutons rad
		attitudebk:SetWidth(16) -- définit la largeur des rad btns
		attitudebk:SetPoint("TOPLEFT", editBox, "TOPRIGHT", 12, 0)
		attitudebk:SetPoint("BOTTOMLEFT", hparrowup, "BOTTOMRIGHT", 12, 0)
		-------------- btns radio
		for index = 0, 2, 1 do
			local radBtn = Npcm.createBtnAttitude(attitudebk, "$parent_radBtnAttitude_"..index, index, i)
		end
	end
end

function Npcm.createUpDownButton(parent, lineIndex, actionType, width, height) -- str "up" / "down"
	local text = "◄"
	if (actionType == "up") then text = "►" end
	local button = Npcm.createRectButton("$parent_HP_"..actionType, parent, text, 30, 30)
	button:SetSize(width, height)
	local color = Npcm.changeColor({parent.r, parent.g, parent.b}, 0)-- -0.05
	Npcm.setColoredButton(button, color, nil, 0, 0, 0.6, nil)
	Npcm.setFontStyle(button.text, "Arial", 16, "5E6C91", false, 0.8)

--[[ version avec texture de 16x16 px
	local button = CreateFrame("Button", "$parent_HP_"..actionType, parent)
	button:SetSize(width, height)
	Npcm.setTexturedFrame(button, nil, Npcm.getStuffPath("dm\\hp_"..actionType, true), 16, 16, 1, 0.7)
--]]

	-------------- scripts
	button:SetScript("OnClick", function()
		Npcm.clickMJ(lineIndex)
		Npcm.majHPbarMJ(lineIndex, actionType, true)
	end)
	return button
end

function Npcm.majHPbarMJ(lineIndex, strUpDown, sendUpdate)
	local strUpDown = strUpDown or "" -- pas de corrections si vide
	------------- new HP value
	local currentPercentHPvalue = NPCM_SAVED["markers"][lineIndex]["hp"] -- %
	local newHPvalue = Npcm.getNewHPvalue(currentPercentHPvalue, strUpDown)
	------------- HP width
	local totalWidth = _G["npcm_frameBk_fLine_"..lineIndex.."_hp_bk"]:GetWidth() - 2
--Npcm.testPrint("majHPbarMJ() : lineIndex="..lineIndex.."  totalWidth="..totalWidth.."  currentPercentHPvalue="..currentPercentHPvalue.."  strUpDown="..strUpDown.."  newHPvalue="..newHPvalue.."  Npcm.percentHP()="..Npcm.percentHP(newHPvalue, totalWidth).."---"..max(0, Npcm.percentHP(newHPvalue, totalWidth)))--/////
	--_G["npcm_frameBk_fLine_"..lineIndex.."_hp"]:SetWidth(max(1, Npcm.percentHP(value["hp"], totalWidth)))
	local pixWidth = Npcm.percentHP(newHPvalue, totalWidth)
	local hpBar = _G["npcm_frameBk_fLine_"..lineIndex.."_hpBar"]
	if (pixWidth > 0) then
		hpBar:SetWidth(pixWidth)
		hpBar:Show()
	else
		hpBar:Hide()
	end
	
	if (sendUpdate == true) then Npcm.setHP(lineIndex, newHPvalue) end -- valeur absolue
end

function Npcm.getNewHPvalue(currentPercentHPvalue, strUpDown) -- up ou down des HPs (MJ) : renvoit un %
	local currentPercentHPvalue = Npcm.nombreParDefaut(currentPercentHPvalue, 100, 0, 100)
	local hpSensibility = Npcm.entierParDefaut(NPCM_SAVED["settings"]["mj"]["hpprecision"], 4, 2, 10)
	local modifHP = 100/hpSensibility
	local newPercentValue = 0
	if (strUpDown == "up") then
		newPercentValue = min(100, currentPercentHPvalue + modifHP)
	elseif (strUpDown == "down") then
		newPercentValue = max(0, currentPercentHPvalue - modifHP)
--Npcm.testPrint("getNewHPvalue() : currentPercentHPvalue="..currentPercentHPvalue.."  hpSensibility="..hpSensibility.."  modifHP="..modifHP.."  tmp="..currentPercentHPvalue - modifHP.."  newPercentValue="..newPercentValue)--/////
	else
		newPercentValue = currentPercentHPvalue
	end
	return newPercentValue -- %
end

function Npcm.createBtnAttitude(parent, name, index, lineIndex)
	local btnHeight = 10
	local radBtn = Npcm.createRectButton(name, parent, "", parent:GetWidth(), btnHeight)
	local bkColor = Npcm.getRGBColorLine(index, false)
	Npcm.setColoredButton(radBtn, bkColor, nil, 0, 1, 0.6, nil)
	radBtn:SetPoint("TOP", parent, "TOP", 0, -index * (btnHeight + 6)) -- 6 = espace inter boutons
	--Npcm.setFontStyle(radBtn.fontString, "Arial", 12, "555555", false, 0.8)
	--local bkColorHi = Npcm.getRGBColorLine(index, true)
	------------------------------------- fcns
	radBtn.SetChecked = function(self, boolean)
		radBtn.checked = Npcm.isTrue(boolean)
		if (radBtn.checked) then
			self:Hide()
		else
			self:Show()
		end
		
--[[ version avec diminution hauteur
		local index = tonumber(string.sub(self:GetName(), -1, -1))
		local offset = 0
		if (radBtn.checked) then
			offset = -4
			self:SetHeight(btnHeight - 6)
			self:Hide()
		else
			self:SetHeight(btnHeight)
			self:Show()
		end
		self:SetPoint("TOP", self:GetParent(), "TOP", 0, -index * (btnHeight + 6) + offset) -- 6 = espace inter boutons
--]]
--[[ version avec repère texte
		if (radBtn.checked) then
			Npcm.setColoredButton(radBtn, bkColorHi, nil, 0, 1, 0, nil)
			self:SetText("•")
		else
			Npcm.setColoredButton(radBtn, bkColor, nil, 0, 1, 1, nil)
			self:SetText("")
		end
--]]
--[[ version avec cadre
		if (radBtn.checked) then
			Npcm.createBorder(radBtn, 1, "CCCCCC", 0.8)
		else
			Npcm.createBorder(radBtn, 0, nil, nil)
		end
--]]
	end
	radBtn.GetChecked = function(self)
		return (radBtn.checked or false)
	end
	------------------------------------- scripts
	radBtn:SetScript("OnClick", function()
		Npcm.clickMJ(lineIndex)
		Npcm.allumeRadioBtnsAttitude(lineIndex, index, true)
	end)
end

function Npcm.allumeRadioBtnsAttitude(lineIndex, indexHi, sendUpdate)
	for i = 0, 2 do
		_G["npcm_frameBk_fLine_"..lineIndex.."_attitude_radBtnAttitude_"..i]:SetChecked(false)
	end
	if (indexHi < 3) then
		_G["npcm_frameBk_fLine_"..lineIndex.."_attitude_radBtnAttitude_"..indexHi]:SetChecked(true)
	end
	if (sendUpdate == true) then Npcm.setAttitude(lineIndex, indexHi) end
end

function Npcm.createBtnMarker(parent, name, label, lineIndex)
	local button = CreateFrame("Button", name, parent, "SecureActionButtonTemplate")
	button:SetSize(36, parent:GetHeight() - 18)
	------------------------------- couleur
	local color = Npcm.changeColor({parent.r, parent.g, parent.b}, 0.08)
	Npcm.setColoredFrame(button, color, nil, 0, 1, nil)
	-------------- text (icone)
	local text = button:CreateFontString("$parentText", "OVERLAY", "GameFontNormalSmall")
	text:SetPoint("CENTER", "$parent", "CENTER", 0, 6)
	text:SetJustifyH("CENTER")
	button.text = _G[button:GetName().."Text"]
	button.text:SetTextHeight(16)
	button.text:SetText(label)
	------------------------------- clicks
	button:SetMouseClickEnabled(true) -- Make sure OnClick is enabled
	if (Npcm.wowMasterVersion() < 10) then
		button:RegisterForClicks("AnyUp")
	else
		button:RegisterForClicks("AnyUp", "AnyDown") -- up and down required for SecureActionButtonTemplate (wow10)
	end
	---------------------- clicks droit ou gauche
	button:SetAttribute("type", "macro")
	local macroStr1 = format("/wm %d", markersOrder[lineIndex]) -- left button
	button:SetAttribute("macrotext1", macroStr1)
	local macroStr2 = format("/npcm f_cleanline "..lineIndex) -- right button
	button:SetAttribute("macrotext2", macroStr2)
	---------------------- MAJ clicks gauche
	local shiftMacroStr1 = "/npcm f_typemarker {rt"..texGroundMarkers[lineIndex]["numRaidIcn"].."}"..lineIndex
	button:SetAttribute("shift-macrotext1", shiftMacroStr1) -- insertion icone dans chat avec MAJ
	----------------------
	button:SetScript("PostClick", function(self, mouse, isDown)
		if (not isDown) then -- pour ne pas exécuter l'action au up ET down
			Npcm.clickMJ(lineIndex)
			if (not IsModifierKeyDown()) then -- sinon : click modifié
				if (mouse == "LeftButton") then
					Npcm.showMarker(lineIndex)
				else
					Npcm.hideMarker(lineIndex)
				end
			end
		end
	end)
	-------------------------------  tooltip
	button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:AddLine(Npcm.getLocal("Click to place marker."))
		GameTooltip:AddLine(Npcm.getLocal("Shift-click to insert marker icon into active chat box."))
		GameTooltip:AddLine("|cFFE68080"..Npcm.getLocal("Right-click to remove marker or clean marker data."))
		GameTooltip:Show()
	end)
	button:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	------------------------------- 
	return button
end

function Npcm.settingsRedrawUIMJ(darkModeBoolean) -- recoloration des elements de l'UI MJ après changement style interface
--[[
	for i = 1, #markersOrder do
		local lineName = "npcm_frameBk_fLine_"..i
		local fLine = _G[lineName]
		if (fLine ~= nil) then
			------ ligne
			--fLine
			------ edit box
			local editBoxTexture = _G[lineName.."_editBox_tex"]
		end
	end
	----- status
	---- btn Update
	--npcm_frameBk_status_update
--]]
end

function Npcm.setComm(str, delaySecond) -- affichage d'un texte dans le frame "status" du MJ, avec durée
	if (str ~= nil) then -- accepte "" (effacement du comm existant)
		if (Npcm.frameExists(npcm_frameBk_status) and npcm_frameBk_status:IsVisible()) then
			npcm_frameBk_status:SetText(Npcm.videSiNul(str))
			if (delaySecond ~= nil and delaySecond ~= 0) then C_Timer.After(delaySecond, function() Npcm.setComm("", 0) end); end
		end
	end
end
	
function Npcm.expandUI(value) -- déroulage de l'UI du MJ
	if (npcm_frameMain:IsVisible()) then
		local val
		if (value == nil) then
			----------- switch
			val = (not npcm_frameBk:IsVisible())
		else
			----------- given value
			val = Npcm.isTrue(value, true)
		end
		
		if (val) then
			Npcm.setFrameHeight(addonVar["dimUImj"]["vMenuBar"] + addonVar["dimUImj"]["vStatus"] + ((addonVar["dimUImj"]["vLine"] + 1) * #markersOrder))
			npcm_frameBk:Show()
			NPCM_SAVED["settings"]["mj"]["expanded"] = 1
		else
			npcm_frameBk:Hide()
			Npcm.setFrameHeight(addonVar["dimUImj"]["vMenuBar"])
			NPCM_SAVED["settings"]["mj"]["expanded"] = 0
		end
	end
end

function Npcm.populateFrameMJ(comm, delay) -- delay est passé pour setComm()
	--Npcm.updateMarkers()-- trop tôt : marker non visible si pas encore placé/cliqué
	---------------------------- lignes
	for i, value in ipairs(NPCM_SAVED["markers"]) do
  		_G["npcm_frameBk_fLine_"..i.."_editBox"]:SetText(Npcm.videSiNul(value["text"]))
  		Npcm.majHPbarMJ(i, "", false) -- pas de MAJ client immédiat
  		Npcm.allumeRadioBtnsAttitude(i, Npcm.entierParDefaut(value["attitude"], 3), false) -- pas de MAJ client immédiat
  		--NOBOSS _G["npcm_frameBk_fLine_"..i.."_checkBoss"]:SetChecked(Npcm.isTrue(value["boss"]));
  		
  		Npcm.colorizeMJline(i)
	end
	--------------------------- status
	if (not Npcm.isGrouped(true)) then
		if (Npcm.inInstance()) then
			Npcm.setComm(Npcm.getLocal("Warning: you are in instance group!"), 10)
		else
			Npcm.setComm(Npcm.getLocal("Warning: not in party or raid!"), 10)
		end
	else
		Npcm.setComm(comm, delay)
	end
end

function Npcm.colorizeMJline(lineIndex)
	local attitude = NPCM_SAVED["markers"][lineIndex]["attitude"] -- 0, 1, 2 ou 3 -- inactif par défaut
	local color = Npcm.getRGBColorLine(3, false)
	local alphaTable = alphasMJ["normal"]
	if (Npcm.isDarkMJ()) then alphaTable = alphasMJ["dark"] end
	
	local markerBtn = _G["npcm_frameBk_fLine_"..lineIndex.."_icn"]
	local macroStr = "/npcm f_cleanline "..lineIndex -- macro : effacement data marker par défaut
	if (Npcm.isTrue(NPCM_SAVED["markers"][lineIndex]["visible"])) then
		------------- marker visible : ligne active
		alphaTable = alphaTable["active"]
		macroStr = format("/cwm %d", markersOrder[lineIndex]) -- changement macro : suppression marker
		color = Npcm.getRGBColorLine(attitude, false)
		Npcm.setColoredFrame(markerBtn, color, nil, 0, 0.6, nil) -- couleur marker
	else
		------------- marker non visible : ligne inactive
		alphaTable = alphaTable["inactive"]
	end
	markerBtn.texture:SetAlpha(alphaTable["marker"]) -- alpha marker
	markerBtn:SetAttribute("macrotext2", macroStr)
	------ couleur et alpha fond Description
	local frame = _G["npcm_frameBk_fLine_"..lineIndex.."_editBox"]
	Npcm.setColoredFrame(frame, color, nil, 0, 0.8, nil) -- couleur
	frame.texture:SetAlpha(alphaTable["desc"]) -- alpha
	------ couleur et alpha barre HP
	local texture = _G["npcm_frameBk_fLine_"..lineIndex.."_hpBar_tex"]
	texture:SetTexture(Npcm.getStuffPath("player\\hpcli_"..attitude, true))
	texture: SetAlpha(alphaTable["hp"])
	------ 
	_G["npcm_frameBk_fLine_"..lineIndex.."_attitude"]:SetAlpha(alphaTable["attitudebtn"]) -- alpha btn rads attitude
	_G["npcm_frameBk_fLine_"..lineIndex.."_icnText"]:SetAlpha(alphaTable["icnmarker"]) -- alpha icone raid
	_G["npcm_frameBk_fLine_"..lineIndex]:SetAlpha(alphaTable["line"]) -- alpha ligne
end

-------------------------------------- popup menu
function Npcm.createMenu()
	local menuTable = {}
	
	menuTable.text = Npcm.getLocal("Collapse / Expand")
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.expandUI() end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Check Players")
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.commCheck() end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Clean All NPCs data")
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.cleanMarkersData() end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Settings...")
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.showConfig() end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Reset Settings")
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.reset() end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Close Addon")
	menuTable.colorCode = "|cffEE562B"
	menuTable.notCheckable = true
	menuTable.func = function() Npcm.activateClose(true) end
	UIDropDownMenu_AddButton(menuTable)
	
	menuTable.text = Npcm.getLocal("Cancel")
	menuTable.colorCode = "|cffA0B0FA"
	menuTable.notCheckable = true
	menuTable.func = function() end
	UIDropDownMenu_AddButton(menuTable)
end

function Npcm.showMenu()
	ToggleDropDownMenu(1, nil, npcm_frameMain_menubar_popupList, npcm_frameMain_menubar_popupBtn, -15, 3)
end

-------------------------------------- MJ functions

function Npcm.clickMJ(i) -- faire perdre le focus aux champs Desc (MAJ de SAVED sur perte focus)
	_G["npcm_frameBk_fLine_"..i.."_editBox"]:ClearFocus()
end

function Npcm.setDesc(i) -- validation text ligne
	local box = _G["npcm_frameBk_fLine_"..i.."_editBox"]
	Npcm.updateMarkers()
	Npcm.updateSavedMarker(i, "text", box:GetText()) -- MAJ de NPCM_SAVED["markers"][i]
	local soundName = "ui"
	if (Npcm.isTrue(NPCM_SAVED["markers"][i]["visible"])) then soundName = "name" end
	Npcm.playUIsounds("mj", soundName)
end

function Npcm.setHP(i, indexHi)
	Npcm.updateMarkers()
	Npcm.updateSavedMarker(i, "hp", indexHi) -- MAJ de NPCM_SAVED["markers"][i]
	local soundName = "ui"
	if (Npcm.isTrue(NPCM_SAVED["markers"][i]["visible"])) then soundName = "hp" end
	Npcm.playUIsounds("mj", soundName)
end

function Npcm.setBoss(i, booleen)
	Npcm.updateMarkers()
	Npcm.updateSavedMarker(i, "boss", Npcm.booleanToInt(booleen)) -- MAJ de NPCM_SAVED["markers"][i]
end

function Npcm.setAttitude(i, indexHi)
	Npcm.updateMarkers()
	Npcm.updateSavedMarker(i, "attitude", indexHi) -- MAJ de NPCM_SAVED["markers"][i]
	local soundName = "ui"
	Npcm.colorizeMJline(i)
	if (Npcm.isTrue(NPCM_SAVED["markers"][i]["visible"])) then soundName = "attitude" end
	Npcm.playUIsounds("mj", soundName)
end

function Npcm.showMarker(i)
	if (not Npcm.isGrouped(true)) then Npcm.setComm(Npcm.getLocal("Not in home party or raid."), 10) end
	-- ne rien faire d'autre ici car le MJ peut annuler le placement par un clic-droit !
	-- voir Npcm.spellOK() à réception de l'event UNIT_SPELLCAST_SUCCEEDED
end

function Npcm.spellOK(unitTarget, castGUID, spellID) -- pour MJ : action sur event UNIT_SPELLCAST_SUCCEEDED
	if (npcm_frameMain:IsVisible()) then
		if (unitTarget == "player") then
			Npcm.testPrint("UNIT_SPELLCAST_SUCCEEDED : spellID="..spellID.."   Name="..GetSpellInfo(spellID).."---")
			local markerIndex = Npcm.getMarkerIdFromSpell(spellID)
			if (markerIndex ~= nil) then
				NPCM_SAVED["markers"][markerIndex]["visible"] = 1
				Npcm.colorizeMJline(markerIndex)
				Npcm.sendUpdateClient(markerIndex, nil)-- MAJ du client ligne i
				Npcm.playUIsounds("mj", "place")
			end
		end
	end
end

function Npcm.hideMarker(i) -- macro btn secure
	C_Timer.After(0.5, function() -- timer pour laisser le temps aux markers avant d'effectuer Npcm.updateMarkers()
		Npcm.updateMarkers()
		Npcm.colorizeMJline(i)
		Npcm.sendUpdateClient(i, nil)-- MAJ du client ligne i
		Npcm.playUIsounds("mj", "clear")
	end)
end

function Npcm.cleanMarker(i) -- macro btn secure : vide les données de la ligne i des markers
	if (NPCM_SAVED["markers"][i]["visible"] == 0) then
		NPCM_SAVED["markers"][i] = Npcm.getEmptyMarkerData()
		_G["npcm_frameBk_fLine_"..i.."_editBox"]:ClearFocus()
		Npcm.populateFrameMJ("")
		return true -- pour cleanMarkersData()
	else
		Npcm.setComm(Npcm.getLocal("Marker is still visible to players."), 10)
		return false -- pour cleanMarkersData()
	end
end

function Npcm.cleanMarkersData()
	local totalBad = 0
	for i = 1, #markersOrder do
		if (not Npcm.cleanMarker(i)) then totalBad = totalBad + 1 end
	end
	if (totalBad == 1) then
		Npcm.echoChatAppl(totalBad.." "..Npcm.getLocal("Marker is still visible to players."), false, "red")
	elseif (totalBad > 1) then
		Npcm.echoChatAppl(totalBad.." "..Npcm.getLocal("Markers are still visible to players."), false, "red") 
	end
end

function Npcm.printMarkersData() -- pour DEV
	print("------------ MJ markers -----------")
	for i, value in ipairs(NPCM_SAVED["markers"]) do
		local color = Npcm.getRGBColorLine(value["attitude"], (value["visible"] == 1))
		Npcm.echoWindow("Marker "..i, color)
		Npcm.echoWindow("    "..Npcm.kwote(value["text"]), color)
		Npcm.echoWindow("    ".."HP = "..value["hp"], color)
	end
	print("---------------------------------------------")
end

function Npcm.updateSavedMarker(i, element, valeur) -- MAJ d'un element de NPCM_SAVED["markers"], et update client
	NPCM_SAVED["markers"][i][element] = valeur
	if (NPCM_SAVED["markers"][i]["visible"] == 1) then Npcm.sendUpdateClient(i, nil); end -- MAJ du client ligne i
end

function Npcm.setFrameHeight(height) -- pour expand/collapse de l'UI MJ
	npcm_frameMain.x = npcm_frameMain:GetLeft()
	npcm_frameMain.y = npcm_frameMain:GetTop()
	npcm_frameMain:SetHeight(height)
	npcm_frameMain:ClearAllPoints()
	npcm_frameMain:SetPoint("TOPLEFT", npcm_frameMain:GetParent(), "BOTTOMLEFT", npcm_frameMain.x, npcm_frameMain.y)
end

function Npcm.showHideAssistWarning(booleen)
	if (Npcm.isTrue(
NPCM_SAVED["settings"]["mj"]["showWarning"])) then Npcm.showAlert("|cFF"..addonVar["chatColor"]..addonVar["name"].."|r\n\n\n"..Npcm.getLocal("You are now an").." "..Npcm.getTxtColor("assistant", "red")..".\n"..Npcm.getLocal("If you don't want to be, ask the Dungeon Master to demote you.")) end
end

---------------------------------------------------------------------------------------
----------------------------------- FRAME CLIENT --------------------------------------

function Npcm.constructionFrameClient()
	------------------------------------------------------------------ frame
	npcm_frameClient = CreateFrame("Frame", "npcm_frameClient", UIParent)
	npcm_frameClient:SetMovable(true)
	npcm_frameClient:SetClampedToScreen(true)
	npcm_frameClient:SetUserPlaced(true)
	npcm_frameClient:Hide()
	npcm_frameClient:ClearAllPoints()
	local clientHeight = 5 -- invisible si 0
	--if (Npcm.debug()) then clientHeight = addonVar["dimUIclient"]["vLine"] * #markersOrder; end
	npcm_frameClient:SetSize(addonVar["dimUIclient"]["hFrame"], clientHeight)
	-------------- texture
	npcm_frameClient.texture = npcm_frameClient:CreateTexture(nil,"BACKGROUND")
	npcm_frameClient.texture:SetAllPoints(true)
	--texture:SetColorTexture(0.3, 0.3, 0.7, 0.4) -- dev
	------------------------------------------------------------------ poignée haut
	local handler = CreateFrame("Button", "$parent_handler", npcm_frameClient)
	handler:SetSize(128, 32)
	handler:SetPoint("BOTTOM", npcm_frameClient, "TOP", 0, -10)
	-------------- texture
	handler.texture = handler:CreateTexture("$parent_tex", "ARTWORK")
	handler.texture:SetAllPoints(true)
	handler.texture:SetTexture(Npcm.getStuffPath("player\\handler", true))
	local handlerHiTex = handler:CreateTexture(nil, "HIGHLIGHT")
	handlerHiTex:SetAllPoints(true)
	handlerHiTex:SetTexture(Npcm.getStuffPath("player\\handler_hi", true))
	-------------- tooltip
    handler:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOM")
		GameTooltip:AddLine("|cFF"..addonVar["chatColor"]..addonVar["name"].." "..Npcm.getVersionStr().."|r\n")
		GameTooltip:AddLine(Npcm.getLocal("Shift-drag to move the frame."))
		GameTooltip:AddLine(Npcm.getLocal("Click to update markers."))
		GameTooltip:Show()
    end)
    handler:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	------------- drag déplacement
	handler:EnableMouse(true)
	handler:SetScript("OnMouseDown", function(self, mouse)
		if (mouse == "LeftButton" and IsModifierKeyDown() and not npcm_frameClient.isMoving) then
			-------- début drag
			self:GetParent():StartMoving()
			self:GetParent().isMoving = true
		else
			-------- simple click
			Npcm.refresh() -- avec Npcm.askUpdateClient() -- demande d'update au MJ
			Npcm.echoChat("|cFF"..addonVar["chatColor"]..addonVar["name"]..Npcm.getTxtColor(": markers updated.", "blue"), "SYSTEM", true);
		end
	end)
	handler:SetScript("OnMouseUp", function(self, mouse)
		if (mouse == "LeftButton" and npcm_frameClient.isMoving) then
			self:GetParent():StopMovingOrSizing()
			self:GetParent().isMoving = false
			Npcm.saveFramesPosition()
		end
	end)
	
	------------------------------------------------------------------ lignes
	Npcm.createUIlinesClient()
	------------------------------------------------------------------ 
	npcm_frameClient:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Npcm.entierParDefaut(NPCM_SAVED["settings"]["client"]["posX"], 70), Npcm.entierParDefaut(NPCM_SAVED["settings"]["client"]["posY"], 600))
end

function Npcm.createUIlinesClient() -- creation d'une ligne par world marker
	for i = 1, #markersOrder do
		-------------------------------------------- frame ligne
		local fLine = CreateFrame("Frame", "$parent_fLine_"..i, npcm_frameClient)
		fLine:SetFrameStrata("BACKGROUND")
		fLine:SetSize(npcm_frameClient:GetWidth(), addonVar["dimUIclient"]["vLine"])
		fLine:SetPoint("TOPLEFT", npcm_frameClient, "TOPLEFT", 0, 0 - (i + addonVar["dimUIclient"]["vLine"]*(i - 1)))
		
		-------------------------------------------- icone marker
		local icn = CreateFrame("Button", "$parent_icn", fLine)
		icn:SetSize(addonVar["dimUIclient"]["icon"], addonVar["dimUIclient"]["icon"])
		icn:SetPoint("TOPLEFT", fLine, "TOPLEFT", 0, 0)
		local icnTex = icn:CreateTexture(nil, "ARTWORK")
		icnTex:SetAllPoints(true)
		--icnTex:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_"..i) -- MAJ populate
		icn.texture = icnTex
		-------------- scripts
		icn:SetScript("OnClick", function(self, mouse) -- insertion icone marker dans chat box avec MAJ
			--local numIconMarker = texGroundMarkers[i]["numRaidIcn"]
			if (IsShiftKeyDown()) then
				local numIconMarker = fLine.numIcn -- prop frame
				local devInfos = ""
				if (Npcm.debug()) then devInfos = "   ("..numIconMarker..")" end
				if (numIconMarker ~= nil) then
					local txtTarget = Npcm.videSiNul(Npcm.escapeQuote(fLine.desc)) -- prop frame
					Npcm.chatEditInsertMarker(txtTarget.." {rt"..texGroundMarkers[numIconMarker]["numRaidIcn"].."}"..devInfos, texGroundMarkers[numIconMarker]["tex"])
				end
			end
		end)
		-------------- tooltip
		icn:SetScript("OnEnter", function(self)
			icn:SetAlpha(0.6)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(Npcm.getLocal("Shift-click to insert marker icon into active chat box."))
			GameTooltip:Show()
		end)
		icn:SetScript("OnLeave", function(self)
			icn:SetAlpha(1)
			GameTooltip:Hide()
		end)
		-------------------------------------------- barre HP
		----------------------- fond
		local hpBar = CreateFrame("Frame", "$parent_hpBar", fLine)
		hpBar:SetSize(addonVar["dimUIclient"]["hFrame"] - addonVar["dimUIclient"]["icon"] - 10, 8)
		hpBar:SetPoint("TOPLEFT", icn, "TOPRIGHT",6 , -3)
		local hpBarTex = hpBar:CreateTexture(nil, "BORDER")
		hpBarTex:SetAllPoints(true)
		hpBarTex:SetColorTexture(1, 1, 1, 0.3)
		hpBar.hpBarTex = texture
		----------------------- HP
		local hp = CreateFrame("Frame", "$parent_hp", fLine)
		hp:SetSize(1, hpBar:GetHeight() + 2) -- MAJ populate
		hp:SetPoint("LEFT", hpBar, "LEFT", 0, 1)
		local hpTex = hp:CreateTexture("$parent_tex", "ARTWORK")
		hpTex:SetAllPoints(true)
		--hpTex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\player\\hpcli_0") -- MAJ populate
		hp.texture = hpTex
		-------------------------------------------- num icone (pour insertion icone marker dans chat box par MAJ click)
		local labelNumIcn = fLine:CreateFontString("$parent_numIcn_text", "OVERLAY", "GameFontNormalSmall")
		labelNumIcn:SetPoint("TOPRIGHT", hpBar, "BOTTOMRIGHT", 0, -4)
		labelNumIcn:SetText("") -- MAJ populate
		if (Npcm.debug()) then labelNumIcn:Show() else labelNumIcn:Hide() end
		-------------------------------------------- texte
		local txt = fLine:CreateFontString("$parent_text", "OVERLAY", "GameFontNormalSmall")
		txt:SetPoint("LEFT", hpBar, "BOTTOMLEFT", 0, -9)
		txt:SetText(""..i) -- MAJ populate
	end
end

function Npcm.populateFrameClient() -- MAJ de l'UI client d'après NPCM_SAVED["markers"] et affiche l'UI client
	for i = 1, #markersOrder do
		_G["npcm_frameClient_fLine_"..i]:Hide()
	end
	
	local cpt = 0
	for i, value in pairs(NPCM_SAVED["markers"]) do
		if (tonumber(value["visible"]) == 1) then
			cpt = cpt + 1
			------------- marker icon
			_G["npcm_frameClient_fLine_"..cpt.."_icn"].texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_"..texGroundMarkers[i]["numRaidIcn"])
			------------- HP couleur
			_G["npcm_frameClient_fLine_"..cpt.."_hp"].texture:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\player\\hpcli_"..value["attitude"])
			------------- HP width
			local totalWidth = _G["npcm_frameClient_fLine_"..cpt.."_hpBar"]:GetWidth()
--Npcm.testPrint("totalWidth="..totalWidth.." cpt="..cpt.." value[hp]="..value["hp"].." Npcm.percentHP()="..Npcm.percentHP(value["hp"], totalWidth).."---"..max(0, Npcm.percentHP(value["hp"], totalWidth)))--/////
			local pixWidth = Npcm.percentHP(value["hp"], totalWidth)
			if (pixWidth > 0) then
				_G["npcm_frameClient_fLine_"..cpt.."_hp"]:SetWidth(pixWidth)
				_G["npcm_frameClient_fLine_"..cpt.."_hp"]:Show()
			else
				_G["npcm_frameClient_fLine_"..cpt.."_hp"]:Hide()
			end
			------------- NOBOSS
			------------- text (desc)
			local str = value["text"]
			if (Npcm.debug()) then str = str.." ("..i.."-"..texGroundMarkers[i]["numRaidIcn"]..")"; end
			_G["npcm_frameClient_fLine_"..cpt.."_text"]:SetText(str)
			_G["npcm_frameClient_fLine_"..cpt].desc = str -- prop frame : raccourci pou insertion MAJ
			------------- num icon (pour insertion icone marker dans chat box)
			_G["npcm_frameClient_fLine_"..cpt.."_numIcn_text"]:SetText(i)
			_G["npcm_frameClient_fLine_"..cpt].numIcn = i -- prop frame : raccourci
			-------------
			_G["npcm_frameClient_fLine_"..cpt]:Show()
		end
	end
	npcm_frameClient:Show() -- toujours visible (poignée haut)
end

function Npcm.percentHP(HPvalue, totalWidth) -- switch suivant version (pour rétrocompatibilité)
	if (HPvalue - 4 <= 0) then
		---------------- MJ v1.1x (HPvalue = 1, 2, 3 ou 4)
		if (Npcm.strToNumber(Npcm.getVar("version")) >= 1.2) then
			------ client %
			local HPconverted = Npcm.radValueToPercent(HPvalue)
--Npcm.testPrint("bbb---converted=",HPconverted, "percentHP100()=", Npcm.percentHP100(HPconverted, totalWidth))--/////
			return Npcm.percentHP100(HPconverted, totalWidth)
		else
			-- client v 1.1x : 1, 2, 3 ou 4 --> ne rien faire
		end
	else
		---------------- MJ v >= 1.20 (HPvalue = %)
		if (Npcm.strToNumber(Npcm.getVar("version")) >= 1.2) then
			------ client %
			return Npcm.percentHP100(HPvalue, totalWidth)
		else
			-- client v 1.1x : % à convertir en 1, 2, 3 ou 4
			local HPconverted = Npcm.percentToRadValue(HPvalue)
--Npcm.testPrint("ccc---converted=",HPconverted, "percentHPrad()=", Npcm.percentHPrad(HPconverted, totalWidth))--/////
			return Npcm.percentHPrad(HPconverted, totalWidth)
		end
	end
end

function Npcm.radValueToPercent(HPvalue) -- pour rétrocompatibilité 1.1x / 1.20
	return ((HPvalue - 1)*100/3)
end

function Npcm.percentToRadValue(HPvalue) -- pour rétrocompatibilité 1.1x / 1.20
	local HPvalue = Npcm.tonumber(HPvalue) or 0 -- secu
	if (HPvalue <= 0) then
		return 0
	elseif (HPvalue <= 50) then
		return 1
	elseif (HPvalue <= 100) then
		return 2
	else
		return 3
	end
end

function Npcm.percentHPrad(HPvalue, totalWidth) -- v 1.1x
	-- return width en fonction des boutons radio HP : 1, 2, 3 ou 4
	return ceil((totalWidth * (HPvalue - 1)/3))
end

function Npcm.percentHP100(HPvalue, totalWidth) -- v >= 1.20
	-- return la largeur en pixel en fonction de HPvalue exprimé en %
	return ceil(totalWidth * HPvalue / 100)
end

---------------------------------------------------------------------------------------
------------------------------- COMMUN (MJ et CLIENT) ---------------------------------

function Npcm.updateMarkers() -- maj du champ "visible" de NPCM_SAVED["markers"] en fonction des markers réellement visibles
	-- renvoit false si problème
	local retOK, ret1 -- pour pcall
	local resu = true
	for i = 1, #markersOrder do
		--Npcm.testPrint(i.." : "..tostring(markersOrder[i]).." - "..tostring(IsRaidMarkerActive(markersOrder[i])))--/////
		retOK, ret1 = pcall(IsRaidMarkerActive, i)
		if (retOK == true) then
			NPCM_SAVED["markers"][i]["visible"] = Npcm.booleanToInt(IsRaidMarkerActive(markersOrder[i]))
		else
			resu = false
			break
		end
	end
	--if (Npcm.debug()) then Npcm.showRealMarkers(); end
	return resu
end

function Npcm.constructionFrames()
	Npcm.constructionFrameMJ() -- mise à jour du frame principal (créé en XML)
	Npcm.constructionFrameClient()
	Npcm.constructionFrameListPlayers() -- mise à jour du frame de liste des joueurs (créé en XML)
end

function Npcm.populateFrames(comm, delay) -- peuple le frame avec les données de NPCM_SAVED["markers"]
	if (Npcm.isTrue(NPCM_SAVED["settings"]["forceClient"])) then -- pour dev
		Npcm.populateFrameClient()
	else
		if (Npcm.isMJ()) then
			Npcm.populateFrameMJ(comm, delay)
		else
			Npcm.populateFrameClient()
		end
	end
end

function Npcm.flashNPC() -- effet visuel
	local delay = 1 -- seconde
	if (npcm_frameMain:IsVisible()) then
		npcm_frameMain_menubar_tex:SetAlpha(0.6)
		npcm_frameMain_menubar_tex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\dm\\Npcm_menuBk_over")
		C_Timer.After(0.1, function()
			npcm_frameMain_menubar_tex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\dm\\Npcm_menuBk")
		npcm_frameMain_menubar_tex:SetAlpha(1)
		end)
	elseif (npcm_frameClient:IsVisible()) then
		npcm_frameClient_handler_tex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\player\\handler_hi")
		C_Timer.After(delay, function()
			npcm_frameClient_handler_tex:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\player\\handler")
		end)
	end
end

function Npcm.showAlert(msg) -- simple alert
	StaticPopupDialogs["NPCM_ALERT"] = {
		text = "%s".."\n ",
		button1 = "OK", -- ACCEPT,
		button2 = nil, -- CANCEL,
		OnAccept = function(self)
			-- print("test")
		end,	
		showAlert = 1, -- icon warning
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
		preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
	};
	StaticPopup_Show("NPCM_ALERT", msg) 
end

function Npcm.updatePartyIcon(rank) -- MAJ icone repère MJ : RL ou RA
	if (npcm_frameMain:IsVisible()) then
		if (rank == nil) then rank = 0 end -- secu
		if (Npcm.inRaid()) then -- attention à l'ordre du test : ne pas intervertir !
			if (rank == 1) then -- RA
				npcm_frameMain_menubar_partyIcon.texture:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\dm\\crown_ra")
				npcm_frameMain_menubar_partyIcon:Show()
			else
				npcm_frameMain_menubar_partyIcon:Hide()
			end
		elseif (Npcm.inParty()) then
			if (rank >= 1) then -- party leader
				npcm_frameMain_menubar_partyIcon.texture:SetTexture("Interface\\AddOns\\NPCsMarkers\\stuff\\dm\\crown_party")
				npcm_frameMain_menubar_partyIcon:Show()
			else
				npcm_frameMain_menubar_partyIcon:Hide()
			end
		end
		-- ne rien faire si en instance
	end
end

function Npcm.playUIsounds(kind, actionName)
	-- test si sound dans confif UI
	if (Npcm.isTrue(NPCM_SAVED["settings"][kind]["sounds"])) then PlaySound(Npcm.getSounds(actionName)) end
end

function Npcm.chatEditInsertMarkerMJ(strMarker, iconTex) -- spécial au MJ
	local tbl = {strsplit("}", strMarker)}
	local numMarker = tonumber(tbl[2])
	local txtTarget = Npcm.videSiNul(Npcm.escapeQuote(NPCM_SAVED["markers"][numMarker]["text"]))
	local strToInsert = txtTarget.." "..Npcm.videSiNul(tbl[1]).."}"

	if (not Npcm.chatEditInsertText(strToInsert)) then
		local iconTex = iconTex or "this marker." -- secu
		Npcm.echoChatAppl(Npcm.getLocal("No opened chat box to insert").." "..tostring(iconTex), false, "red")
		Npcm.setComm(Npcm.getLocal("No opened chat box."), 10) -- pour MJ
	end
end

function Npcm.chatEditInsertMarker(strMarker, iconTex)
	if (not Npcm.chatEditInsertText(strMarker)) then
		local iconTex = iconTex or "this marker." -- secu
		Npcm.echoChatAppl("No opened chat box to insert "..tostring(iconTex), false, "red")
		Npcm.setComm(Npcm.getLocal("No opened chat box."), 10) -- pour MJ
	end
end

function Npcm.chatEditInsertText(str)
	if (str ~= nil and type(str) == "string") then
		local chatBoxNameFrame, chatBoxName = Npcm.getActiveChatBox()
		if (chatBoxNameFrame ~= nil) then
			chatBoxNameFrame:SetText(chatBoxNameFrame:GetText()..tostring(str))
			return true
		else
			return false
		end
	else
		return false
	end
end

function Npcm.getActiveChatBox() -- renvoit le frame et le nom de la boite à message active, ou NIL
	if (ACTIVE_CHAT_EDIT_BOX ~= nil) then
		return ACTIVE_CHAT_EDIT_BOX, ACTIVE_CHAT_EDIT_BOX:GetName()
	else
		return nil, nil
	end
end

---------------------------------------------------------------------------------------
------------------------------------ PLAYERS LIST -------------------------------------

function Npcm.constructionFrameListPlayers() -- mise à jour du frame de liste des joueurs (créé en XML)
	---------------------------------------------------- frame principal
	local framePlayers = CreateFrame("frame", "npcm_playersFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	framePlayers:SetFrameStrata("LOW")
	framePlayers:SetClampedToScreen(true)
	framePlayers:SetMovable(true)
 	framePlayers:SetUserPlaced(true)
    framePlayers:SetResizable(false)
	framePlayers:ClearAllPoints()
	framePlayers:SetSize(250, 316)
	framePlayers:SetPoint("CENTER", UIParent, "CENTER", 0, 100)
	if (not Npcm.debug()) then framePlayers:Hide() end
	Npcm.setColoredFrame(framePlayers, "#333333", "#666666", 1, 0.9, nil)
	--------------------------------- barre titre
	local menubar = CreateFrame("Button", "npcm_playersFrame_title", framePlayers)
	menubar:SetSize(framePlayers:GetWidth(), 16)
	menubar:SetPoint("TOPLEFT", framePlayers, "TOPLEFT", 0, 0)
	----------- textures
	Npcm.setTexturedFrame(menubar, "$parent_tex", Npcm.getStuffPath("dm\\Npcm_menuBk", true), nil, nil, 1, 0.2)
	------------- titre
	menubar.text = menubar:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormalSmall")
	menubar.text:SetPoint("CENTER", 0, 0)
	menubar.text:SetJustifyH("CENTER")
	menubar.text:SetText(Npcm.getVar("name").." "..Npcm.getVersionStr().." - "..Npcm.getLocal("players list"))
    menubar:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	------------- drag déplacement
	menubar:EnableMouse(true)
	menubar:SetScript("OnMouseDown", function(self, mouse)
		if (mouse == "LeftButton" and not npcm_playersFrame.isMoving) then
			self:GetParent():StartMoving()
			self:GetParent().isMoving = true
		end
	end)
	menubar:SetScript("OnMouseUp", function(self, mouse)
		if (mouse == "LeftButton" and npcm_playersFrame.isMoving) then
			self:GetParent():StopMovingOrSizing()
			self:GetParent().isMoving = false
		end
	end)
	---------------------------------------------------- scroll frame : players list ("npcm_playersFrame_scroll")
	Npcm.createPlayersFrame(framePlayers, "npcm_playersFrame_scroll")
	---------------------------------------------------- btns bas
	local frameBottom = CreateFrame("Frame", "npcm_playersFrame_bottom", framePlayers, BackdropTemplateMixin and "BackdropTemplate")
	frameBottom:SetSize(framePlayers:GetWidth(), 18)
	Npcm.setColoredFrame(frameBottom, "#222222", nil, 0, 0.9)
	frameBottom:SetPoint("TOPLEFT", framePlayers, "BOTTOMLEFT", 0, 0)
	------------------------------ bouton Update
	local color = colorMJ["dark"]["update"]
	local btnUpdate = Npcm.createRectButton("npcm_playersFrame_update_Btn", frameBottom, Npcm.getLocal("Update"), 75, frameBottom:GetHeight() - 2)
	Npcm.setColoredButton(btnUpdate, color, "222222", 0, 1, 0.5, nil)
	Npcm.setFontStyle(btnUpdate.text, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "BFB313", false, 1)
	btnUpdate:SetPoint("LEFT", 1, 0)
	btnUpdate:SetScript("OnClick", function() Npcm.commCheck() end)
	------------------------------ bouton Close
	local btnClose = Npcm.createRectButton("npcm_playersFrame_update_Btn", frameBottom, Npcm.getLocal("Close"), 75, frameBottom:GetHeight() - 2)
	Npcm.setColoredButton(btnClose, "9B392F", "222222", 0, 1, 0.5, nil)
	Npcm.setFontStyle(btnClose.text, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "BFB313", false, 1)
	btnClose:SetPoint("RIGHT", -1, 0)
	btnClose:SetScript("OnClick", function() npcm_playersFrame:Hide() end)
	---------------------------------------------------- masque (grisage durant scan)
	local frameMask = CreateFrame("Frame", "npcm_playersFrame_mask", framePlayers, BackdropTemplateMixin and "BackdropTemplate")
	frameMask:SetAllPoints() -- recouvre le parent
	Npcm.setColoredFrame(frameMask, {0.3, 0.3, 0.3}, nil, 0, 0.6)
	-------------- text
	local text = frameMask:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
	Npcm.setFontStyle(text, Npcm.getStuffPath("Myriad Condensed Web.ttf", true), 10, "BFB313", false, 1)
	text:SetPoint("CENTER", "$parent", "CENTER", 0, 0)
	text:SetJustifyH("CENTER")
	frameMask.text = _G[frameMask:GetName().."Text"]
	frameMask.text:SetText(Npcm.getLocal("Checking players..."))
	
--npcm_playersFrame_mask:Hide()--///// pour dev
end

function Npcm.createPlayersFrame(parent, scrollFrameName)
	frameListPlayers = CreateFrame("Frame", scrollFrameName, parent)
	frameListPlayers:SetPoint("TOPLEFT", npcm_playersFrame_title, "BOTTOMLEFT", 0, 0)
	Npcm.setColoredFrame(frameListPlayers, "333333", "333333", 1, 0.6)
	local scrollProps = { -- scroll frame properties (see _scroll.lua for full settings)
		-------------------- height: at least one of these properties must be set
		["height"] = parent:GetHeight() - 18, -- hauteur npcm_playersFrame_bottom
		--------------------
		["width"] = parent:GetWidth(),
		["marginH"] = 1, -- px (margins from background frame : depends on template style)
		["marginV"] = 1, -- px (margins from background frame : depends on template style)
		["alwaysShowArrow"] = true, -- if true, always show scroller up and down arrows
		-------------------- lines
		["lineHeight"] = Npcm.listGetVar("vLine"), -- px
		["lineSpacing"] = 1, -- px
		["cellSpacing"] = 0, -- px // horizontal spacing, if several columns in a line
		-------------------- lines font
		["fontSize"] = 11,
		-------------------- lines background
		["background"] = {0.3, 0.3, 0.3}, -- color, or texture file path
		["alpha"] = 0.6,
		-------------------- scroller buttons images
		["defaultScroller"] = false, -- set to true to standard WoW scroller
		["scrollerWidth"] = 16, -- px : unused if defaultScroller set to true
		["scrollerColor"] = {0.15, 0.15, 0.2}, -- unused if defaultScroller set to true
		["scrollerBarAlpha"] = 0.7, -- unused if defaultScroller set to true
	}
	
	local scrollColumns = { -- columns definition and properties (see _scroll.lua for full settings)
		-- column order, do not use name !
		[1] = { -- player name
			["width"] = 140,
			["type"] = "Button",
			["script"] = "Npcm.listClickLine",
		},
		[2] = { -- player version
			["width"] = 50, -- % value accepted. if 0 or NIL : all the remaining line's width
			["type"] = "Button",
			["script"] = "Npcm.listClickLine",
			["fontAlign"] = "CENTER",
		},
		[3] = { -- active
			["width"] = 0, -- % value accepted. if 0 or NIL : all the remaining line's width
			["type"] = "Button",
			["script"] = "Npcm.listClickLine",
			["fontAlign"] = "CENTER",
		},
	}
	
	Npcm.scrollCreate(frameListPlayers, scrollProps, scrollColumns) -- creates structure (empty scroll lines)
end

function Npcm.listGetVar(nomVar)
	-- get valeurs de la table locale listVars
	-- si aucun argument n'est passé, renvoit la table listVars
	local listVars = {
		["vLine"] = 15, -- hauteur ligne
		["colorLineSelf"] = {0.36,0.46,0.87},
		["colorLineGrey"] = {0.5,0.5,0.5},
		["colorLineOK"] = {0.38,0.6,0.16},
		["colorLineOld"] = {0.68,0.65,0.05},
		["colorLineNo"] = {0.81,0.25,0.17},
		["colorLineAlpha"] = 0.8,
	}

	if (nomVar == nil) then return nil end
	if (listVars[nomVar] ~= nil) then
		return listVars[nomVar]
	else
		return listVars
	end
end

function Npcm.scrollLineUpdate(scrollFrame, lineIndex, dataLineIndex) -- do not modify args !
	local columnFrame
	if (scrollFrame.data ~= nil) then
		local dataLine = scrollFrame.data[dataLineIndex]
		if (dataLine ~= nil) then -- check si resize plus grand que lignes de data
			local bkColor = Npcm.listColorizeLine(dataLine["name"], dataLine["status"])
			local colorTxt = {0.95, 0.94, 0.67}
			if (dataLine["status"] == 0) then colorTxt = {0.7,0.7,0.7} end
			------------------------ column 1: text and texture available
			columnFrame = scrollFrame.line[lineIndex].column[1]
			columnFrame.text:SetText(dataLine["name"])
			columnFrame.text:SetTextColor(colorTxt[1], colorTxt[2], colorTxt[3], 1)
			columnFrame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], 0.8)
			
			------------------------ column 2: text and texture available
			columnFrame = scrollFrame.line[lineIndex].column[2]
			columnFrame.text:SetText(dataLine["version"])
			columnFrame.text:SetTextColor(colorTxt[1], colorTxt[2], colorTxt[3], 1)
			columnFrame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], 0.8)

			------------------------ column 3: text and texture available
			columnFrame = scrollFrame.line[lineIndex].column[3]
			local activeTxt = ""
			if (tonumber(dataLine["active"]) == nil) then
				activeTxt = dataLine["active"]
			else
				if (dataLine["active"] < 1) then activeTxt = "-" end
			end
			columnFrame.text:SetText(activeTxt)
			columnFrame.text:SetTextColor(colorTxt[1], colorTxt[2], colorTxt[3], 1)
			columnFrame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], 0.8)
		end
	end
end

function Npcm.listColorizeLine(name, status) -- colorisation fond ligne (bk)
	local alpha = Npcm.listGetVar("colorLineAlpha")
	local colorBk = {}
	if (string.sub(name, 1, 1) == "*") then
		colorBk = Npcm.listGetVar("colorLineSelf")
	elseif (fullname == (name.."-")) then
		colorBk = Npcm.listGetVar("colorLineGrey")
	elseif (status == 0) then
		colorBk = Npcm.listGetVar("colorLineNo")
	elseif (status == 1) then
		colorBk = Npcm.listGetVar("colorLineOld")
	else
		colorBk = Npcm.listGetVar("colorLineOK")
	end
	return colorBk
end

function Npcm.listPlayersOK()
	npcm_playersFrame_mask:Hide()
	npcm_playersFrame_update_Btn:Show()
end

function Npcm.listPlayersShow()
	npcm_playersFrame_update_Btn:Hide()
	npcm_playersFrame:Show()
	npcm_playersFrame_mask:Show()
	Npcm.listScrollerUpdate()
end

function Npcm.listScrollerUpdate()
	local tblPlayers = Npcm.listGetPlayers()
	Npcm.scrollUpdate(frameListPlayers, tblPlayers)
end

function Npcm.listClickLine(scrollFrameName, clickedColumnName, mouse, lineIndex) -- do not modify args !
 	-- mouse: "LeftButton" | "RightButton"
	-- if (IsModifierKeyDown()...)
	local scrollFrame = _G[scrollFrameName]
	local dataLineIndex, dataLine = Npcm.scrollGetDataLine(scrollFrame, lineIndex)
	if (not Npcm.isEmpty(dataLine)) then -- secu
		if (not Npcm.isEmpty(dataLine["fullname"])) then -- secu
			local playerName, serverName = UnitFullName("player") -- nom condensé du server (sans espace)
			if (string.sub(dataLine["fullname"], -1, -1) ~= "-") then
				if (dataLine["fullname"] ~= nil) then
					if (dataLine["fullname"] ~= playerName.."-"..serverName) then Npcm.listeSendWhisp(dataLine["fullname"]) end
				else
					Npcm.echoChatAppl(": unexpected error 3220.", false, "red")
				end
			else
				Npcm.echoChatAppl(": "..Npcm.getLocal("unable to find player."), false, "orange")
			end
		end
	end
end

function Npcm.listeSendWhisp(playerName)
	if (not Npcm.isEmpty(playerName)) then
		Npcm.testPrint(addonVar["name"].." listeSendWhisp() : playerName="..playerName.."---")
		Npcm.enterMsg("/w "..playerName.." ")
	else
		Npcm.echoChatAppl(": unable to find this player. [3225]", false, "orange");
	end;
end

function Npcm.enterMsg(prefixe) -- tape le debut du message dans la Chat Box pour ouvrir un canal
	ChatFrame_OpenChat(prefixe);
	ChatEdit_ParseText(ChatFrame1.editBox,0)
end
