local addonVar = Npcm.getVar() -- ///// copie de la locale addonVar pour ce fichier
--------------- utilise une sous-table ["settings"]["minimap"]["posX"] et ["posY"] dans la globale _SAVED

local predefinedPositions = {
	["high"] = {-8, 0},
	["trackingUp"] = {-18, -15},
	["trackingDown"] = {-26, -72},
	["hourLeft"] = {18, -130},
	["dateDown"] = {127, -36},
}

------------------------------------------------------------------------------------------------
-------------------------------------- MINIMAP BTN SETTINGS ------------------------------------

local minimapBtnSettings = { -- /////
	["texture"] = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_1",
	["top"] = predefinedPositions["trackingUp"][1],
	["left"] = predefinedPositions["trackingUp"][2],
	["leftClickAction"] = function() Npcm.activate() end, -- laisser vide si pas d'action avec un clic gauche
	["rightClickAction"] = function() Npcm.showConfig() end, -- laisser vide si pas de seconde action avec un clic droit
	["tooltip"] = "|cFF"..addonVar["chatColor"]..addonVar["name"].." "..addonVar["version"].."|r\n\n"..Npcm.getLocal("Open/close").." "..addonVar["name"].."\n"..Npcm.getLocal("Right-click to display config."),	
}

------------------------------------------------------------------------------------------------
--------------------------------- SCALE - TRANSLATE (UTILITIES) --------------------------------

function Npcm.minimapCreate(btnName, posX, posY)
	local function scaleTexture(texture, factor, debugBoolean)
		-- reset : 			texture:SetTexCoord(0, 0, 0, 1, 1, 0, 1, 1) -- normal
		-- reset : texture:SetTexCoord(0, 1, 0, 1)
		-- rotation -90 : 	texture:SetTexCoord(1, 0, 0, 0, 1, 1, 0, 1)
		
		local ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = texture:GetTexCoord()
		if (Npcm.isTrue(debugBoolean)) then Npcm.debugTexture("scaleTexture() ORI", texture, factor, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy, factor) end
		
		local factor = tonumber(factor) or 1 -- si 2 : réduction de moitié !
		if (factor ~= 1) then
			local offset = 0 - ((factor - 1) /2)
			texture:SetTexCoord((ULx * factor) + offset, (ULy * factor) + offset, (LLx * factor) + offset, (LLy * factor) + offset, (URx * factor) + offset, (URy * factor) + offset, (LRx * factor) + offset, (LRy * factor) + offset)
			
			if (Npcm.isTrue(debugBoolean)) then
				ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = texture:GetTexCoord()
				Npcm.debugTexture("scaleTexture() FIN", texture, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
			end
		end
	end

	local function translateTexture(texture, offset, debugBoolean)
		-- reset : 			texture:SetTexCoord(0, 0, 0, 1, 1, 0, 1, 1) -- normal
		local ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = texture:GetTexCoord()
		if (Npcm.isTrue(debugBoolean)) then Npcm.debugTexture("translateTexture() ORI", texture, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy, offset) end
		
		local offset = tonumber(offset) or 0
		if (offset ~= 0) then
			texture:SetTexCoord(ULx + offset, ULy + offset, LLx + offset, LLy + offset, URx + offset, URy + offset, LRx + offset, LRy + offset)
			
			if (Npcm.isTrue(debugBoolean)) then
				ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = texture:GetTexCoord()
				Npcm.debugTexture("translateTexture() FIN", texture, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
			end
		end
	end

	local function debugTexture(comm, texture, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy, arg)
		local comm = comm or ""
		local arg = arg or ""
		print(comm, "---", texture:GetTexture(),"---ULx=", ULx, "---ULy=", ULy, "---LLx=", LLx, "---LLy=", LLy, "---URx=", URx, "---URy=", URy, "---LRx=", LRx, "---LRy=", LRy, "---arg=", arg)
	end

	------------------------------------------------------------------------------------------------
	------------------------------------------ MINIMAP BUTTON --------------------------------------
	local minimapBtn = CreateFrame("Button", btnName, Minimap)
	posX = tonumber(posX)
	posY = tonumber(posY)
	if (posX == nil or posY == nil or posX == 0 or posY == 0) then
		minimapBtn:SetPoint("TOPLEFT", Minimap, "TOPLEFT", tonumber(minimapBtnSettings.top), tonumber(minimapBtnSettings.left))
	else
		minimapBtn:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", posX, posY)
	end
	minimapBtn:SetSize(32, 32)
	minimapBtn:SetFrameStrata("HIGH")
	minimapBtn:SetMovable(true)
	minimapBtn:SetClampedToScreen(true)
	minimapBtn:SetUserPlaced(true)
	minimapBtn.isMoving = false
	minimapBtn:Hide() -- sera éventuellement affichée à la fin du process de chargement
	------------------------------------------------------- textures
	------------------------- icon
	local icon = minimapBtn:CreateTexture("$parent_tex", "BACKGROUND")
	icon:SetTexture(minimapBtnSettings.texture)
	--icon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_1")
	icon:SetAllPoints() -- parent
	scaleTexture(icon, 2, false) -- besoin si icone pas à la bonne taille
	minimapBtn.texture = icon
	------------------------- border
	local border = minimapBtn:CreateTexture("$parent_border", "BORDER")
	border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	border:SetAllPoints() --parent
	scaleTexture(border, 0.6, false) -- bordure trop petite !
	translateTexture(border, -0.2, false)-- bordure décalée !
	minimapBtn.texture = border
	minimapBtn:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
--[[
	local pushedTexture = minimapBtn:CreateTexture("$parent_texPushed", "OVERLAY")
	pushedTexture:SetTexture(minimapBtnSettings.texture)
	pushedTexture:SetAllPoints() -- parent
	--pushedTexture:SetColorTexture(1,0,0, 0.5)
	pushedTexture:SetAlpha(0.1)
	minimapBtn:SetPushedTexture(pushedTexture)
--]]
	
	------------------------------------------------------- tooltip
	minimapBtn:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_LEFT")
		GameTooltip:SetText(minimapBtnSettings.tooltip)
		GameTooltip:Show()
	end)

	minimapBtn:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)

	------------------------------------------------------- clics et drag
	minimapBtn:SetScript("OnMouseDown", function(self, mouse)
		if ((mouse == "LeftButton" and IsModifierKeyDown()) and not self.isMoving) then
			self:StartMoving()
			self.isMoving = true
		end
	end)

	minimapBtn:SetScript("OnMouseUp", function(self, mouse)
		if (self.isMoving) then
			-------------- end drag
			self:StopMovingOrSizing()
			self.isMoving = false
		else
			-------------- click
			if (mouse == "RightButton" and minimapBtnSettings.rightClickAction ~= nil) then
				minimapBtnSettings.rightClickAction()
			else
				if (minimapBtnSettings.leftClickAction ~= nil) then minimapBtnSettings.leftClickAction() end
			end
		end
	end)
end
