local addonVar = Npcm.getVar() -- ///// copie de la locale addonVar pour ce fichier

local panel
local classicMargin = 15
local availableWidth = 622 - (classicMargin * 2)
if (Npcm.isRetail()) then
	classicMargin = 0
	availableWidth = 665
end

----------------------------------------------------------------------------------------
------------------------------------- CONSTRUCTION -------------------------------------

function Npcm.settingsCreate()
	local margeH = classicMargin + 20
	local subFrame, fontString, chkButton
	
	local thisAddon, addonTitle, addonNotes = GetAddOnInfo(addonVar["name"])
	local titleString = panel:CreateFontString(addonVar["settingsPanel"].."_Title", "ARTWORK", "GameFontNormalLarge")
	titleString:SetPoint("TOPLEFT", 5, -5)
	titleString:SetText(addonTitle.." v"..Npcm.getVersionStr())
	-------------------------- author
	fontString = panel:CreateFontString(addonVar["settingsPanel"].."_Author", "ARTWORK", "GameFontNormalSmall")
	fontString:SetPoint("LEFT", titleString, "RIGHT", 80, -3)
	fontString:SetTextColor(0.5, 0.5, 0.9, 1)
	fontString:SetText("Copyright "..GetAddOnMetadata(Npcm.getVar("name"), "Author"))
	-------------------------- infos/notes
	local infosFrame = Npcm.createTextFrame(nil, panel, availableWidth - (margeH * 2), addonNotes, 0)
	infosFrame:SetPoint("TOPLEFT", titleString, "BOTTOMLEFT", margeH, -5)
	Npcm.setFontStyle(infosFrame.font, nil, 12, "#AAAABB", false, nil)
	-------------------------- chapitre UI MJ
	local mjUI = Npcm.settingsSetChapterTitle(Npcm.getLocal("DM interface"))
	mjUI:SetPoint("TOPLEFT", infosFrame, "BOTTOMLEFT", 0-margeH, -20)
	--------------- scale
	local scaleFrame = CreateFrame("Frame", nil, panel)
	scaleFrame:SetSize(300, 20)
	scaleFrame:SetPoint("TOPLEFT", mjUI, "BOTTOMLEFT", margeH, -10)
	fontString = scaleFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	fontString:SetPoint("LEFT", 0, 0)
	fontString:SetTextColor(0.6, 0.6, 0.6, 1)
	fontString:SetText(Npcm.getLocal("Scale:"))
	subFrame = Npcm.createSlider("npcm_SliderScale", scaleFrame, 200, 0.5, 1, false, false)
	subFrame:SetPoint("LEFT", 200, 0)
	subFrame:SetScript("OnValueChanged", function(self)
		self:SetValue(tonumber(self:GetValue()))
		self:SetText(Npcm.round(self:GetValue(), 2))
		npcm_frameMain:SetScale(tonumber(self:GetValue()))
		NPCM_SAVED["settings"]["mj"]["scale"] = npcm_frameMain:GetScale() -- /////
	end)
	--------------- alpha & dark
	local alphaFrame = CreateFrame("Frame", nil, panel)
	alphaFrame:SetSize(300, 20)
	alphaFrame:SetPoint("TOPLEFT", scaleFrame, "BOTTOMLEFT", 0, -10)
	fontString = alphaFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	fontString:SetPoint("LEFT", 0, 0)
	fontString:SetTextColor(0.6, 0.6, 0.6, 1)
	fontString:SetText(Npcm.getLocal("Transparency:"))
	subFrame = Npcm.createSlider("npcm_SliderAlpha", alphaFrame, 200, 0.5, 1, false, false)
	subFrame:SetPoint("LEFT", 200, 0)
	subFrame:SetScript("OnValueChanged", function(self)
		self:SetValue(Npcm.round(self:GetValue(), 1))
		self:SetText(Npcm.round(self:GetValue(), 1))
		npcm_frameBk:SetAlpha(Npcm.round(self:GetValue(), 1))
		NPCM_SAVED["settings"]["mj"]["alpha"] = self:GetValue() -- /////
	end)

	chkButton = Npcm.createStandardCheckBox("npcm_ChkDarkui", alphaFrame, Npcm.getLocal("Dark interface"))
	chkButton:SetPoint("LEFT", subFrame, "RIGHT", 40, 0)
	chkButton:SetScript("OnClick", function(self)
		local savedStateDark = NPCM_SAVED["settings"]["mj"]["darkui"] -- /////
		NPCM_SAVED["settings"]["mj"]["darkui"] = Npcm.booleanToInt(self:GetChecked())
		if (NPCM_SAVED["settings"]["mj"]["darkui"] ~= savedStateDark) then Npcm.settingsRedrawUIMJ(self:GetChecked()) end
	end)
	chkButton:Hide()--DARKONLY

	--------------- HP accuracy
	local hpFrame = CreateFrame("Frame", nil, panel)
	hpFrame:SetSize(300, 20)
	hpFrame:SetPoint("TOPLEFT", alphaFrame, "BOTTOMLEFT", 0, -10)
	fontString = hpFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	fontString:SetPoint("LEFT", 0, 0)
	fontString:SetTextColor(0.6, 0.6, 0.6, 1)
	fontString:SetText(Npcm.getLocal("NPCs HP Bar Accuracy:"))
	subFrame = Npcm.createSlider("npcm_SliderHP", hpFrame, 200, 2, 10, true, false)
	subFrame:SetPoint("LEFT", 200, 0)
	subFrame:SetScript("OnValueChanged", function(self)
		self:SetValue(Npcm.round(self:GetValue(), 0))
		self:SetText(Npcm.round(self:GetValue(), 0))
		NPCM_SAVED["settings"]["mj"]["hpprecision"] = Npcm.round(self:GetValue(), 0)
	end)
	-------------------------- chapitre sons
	local snds = Npcm.settingsSetChapterTitle(Npcm.getLocal("Sounds"))
	snds:SetPoint("TOPLEFT", hpFrame, "BOTTOMLEFT", 0-margeH, -20)
	--------------- sons
	chkButton = Npcm.createStandardCheckBox("npcm_ChkMJsounds", panel, Npcm.getLocal("DM sounds"))
	chkButton:SetPoint("LEFT", snds, "RIGHT", 105, -20)
	chkButton:SetScript("OnClick", function(self)
		NPCM_SAVED["settings"]["mj"]["sounds"] = Npcm.booleanToInt(self:GetChecked()) -- /////
	end)
	chkButton = Npcm.createStandardCheckBox("npcm_ChkPlayersounds", panel, Npcm.getLocal("Players sounds"))
	chkButton:SetPoint("LEFT", snds, "RIGHT", 320, -20)
	chkButton:SetScript("OnClick", function(self)
		NPCM_SAVED["settings"]["client"]["sounds"] = Npcm.booleanToInt(self:GetChecked()) -- /////
	end)
	-------------------------- chapitre Informations
	local infos = Npcm.settingsSetChapterTitle(Npcm.getLocal("Informations"))
	infos:SetPoint("TOPLEFT", snds, "BOTTOMLEFT", 0, -40)
	--------------- help
	subFrame = Npcm.createTextFrame("npcm_TextInfos", panel, availableWidth - (margeH * 2), "", 0)
	subFrame:SetPoint("TOPLEFT", infos, "BOTTOMLEFT", margeH, -10)
	Npcm.setFontStyle(subFrame.font, nil, 12, "#CCCCCC", false, nil)
	--------------- cmds
	infos = Npcm.createTextFrame("npcm_TextCmds", panel, availableWidth - (margeH * 2), "", 15)
	infos:SetPoint("TOPLEFT", subFrame, "BOTTOMLEFT", 0, -15)
	Npcm.setFontStyle(infos.font, nil, 10, "#CCCCCC", false, nil)
	Npcm.setRoundBorderedFrame(infos, nil, nil, nil)
	-------------------------- btn activate
	subFrame = CreateFrame("Button", "npcm_BtnActivate", panel, "UIPanelButtonTemplate")
	subFrame:SetText(Npcm.getLocal("Show DM interface"))
	subFrame:SetSize(220, 22)
	subFrame:SetPoint("BOTTOM", panel, "BOTTOM", 0, 30)
end

-------------------------------------------------------- FCNs (templates)
function Npcm.settingsSetChapterTitle(str, fontSize, fontColor)
	local fontString = panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	Npcm.setFontStyle(fontString, nil, fontSize or 12, fontColor or "yellow", false, 1)
	fontString:SetText(str)
	return fontString
end

----------------------------------------------------------------------------------------
----------------------------------- UPDATE (onShow) ------------------------------------

function Npcm.settingsPanelUpdate()
	npcm_SliderScale:SetValue(Npcm.round(npcm_frameMain:GetScale(), 1))
	npcm_SliderAlpha:SetValue(Npcm.round(npcm_frameBk:GetAlpha(), 1))
	--DARKONLY  npcm_ChkDarkui:SetChecked(Npcm.isTrue(NPCM_SAVED["settings"]["mj"]["darkui"]))
	npcm_ChkDarkui:SetChecked(true)
	npcm_SliderHP:SetValue(tonumber(NPCM_SAVED["settings"]["mj"]["hpprecision"]))
	npcm_ChkMJsounds:SetChecked(Npcm.isTrue(NPCM_SAVED["settings"]["mj"]["sounds"]))
	npcm_ChkPlayersounds:SetChecked(Npcm.isTrue(NPCM_SAVED["settings"]["client"]["sounds"]))
	npcm_TextInfos:SetText(Npcm.miniDoc())
	npcm_TextCmds:SetText(Npcm.getLocal("Supported slash-commands").."\n\n"..Npcm.slashCmd_showList(true))
	
	npcm_BtnActivate:SetScript("OnClick", function(self)
		if (Npcm.isActivated()) then
			Npcm.echoChatAppl(Npcm.getLocal("is already running."), false, "red")
		else
			Npcm.activateOpen()
		end
	end)
	npcm_BtnActivate:SetShown(not Npcm.isActivated())
end

function Npcm.miniDoc()
	return Npcm.getLocal("About the DM interface:").."\n\n"..Npcm.getLocal("Possibility to prepare the markers' characteristics before placing them.").."\n"..Npcm.getLocal("Markers placed (visible by the players) are colored according to the linked NPC attitude.").."\n"..Npcm.getLocal("Changes in the characteristics of the placed markers are updated in real time on the players' interface.").."\n\n"..Npcm.getLocal("To force the display of placed markers characteristics, if a disconnection or synchronization error is encountered, use the 'Update' button.")
end

----------------------------------------------------------------------------------------
------------------------- GESTION SETTINGS (ne pas déplacer) ---------------------------

if (panel == nil) then
	------------------------------- création frame settings
	panel = CreateFrame("Frame", addonVar["settingsPanel"])
	local background = panel:CreateTexture()
	background:SetAllPoints(panel)
	background:SetColorTexture(0.1, 0.1, 0.1, 0.15)
	Npcm.settingsCreate()
	panel:SetScript("OnShow", function(self)
		Npcm.settingsPanelUpdate()
	end)
	------------------------------- enregistrement dans le panneau de settings de WoW
	if (Settings ~= nil) then -- wow10
		local category = Settings.RegisterCanvasLayoutCategory(panel, addonVar["name"])
		-- OU, pour un panneau scrolling : local category = Settings.RegisterVerticalLayoutCategory(addonVar["name"])
		Settings.RegisterAddOnCategory(category)
		panel.categoryID = category:GetID() -- pour appel depuis fichier lua principal
	else -- wow classic
		panel.name = addonVar["name"]
		-- panel.okay = function (self) Npcm.settingsValidate() end -- non géré (automatique si wow10)
		-- panel.cancel = function (self) Npcm.settingsCancel() end -- non géré (impossible si wow10)
		panel.default = function (self) Npcm.settingsPanelDefault() end
		panel.refresh = function (self) Npcm.settingsPanelUpdate() end
		InterfaceOptions_AddCategory(panel)
	end
end

function Npcm.settingsPanelDefault()
	if (_G[addonVar["settingsPanel"]]:IsVisible()) then -- sinon, ca concerne pas cet addon
		Npcm.reset()
	end
end
